import * as childProcess from 'child_process';

const PromiseWrapper = cmdType => (options, isConsoleLog = true) => new Promise((resolve, reject) => {
  const result = childProcess[cmdType](options);
  const stdoutChunks = [];
  const stderrChunks = [];

  const capture = chunks => data => {
    chunks.push(data);

    if (isConsoleLog) {
      console.log(data.toString().trim());
    }
  };

  result.stdout.on('data', capture(stdoutChunks));
  result.stderr.on('data', capture(stderrChunks));
  result.on('close', () => {
    stdoutChunks.length ? resolve(stdoutChunks) : reject(stderrChunks);
  });
});

export const spawn = PromiseWrapper('spawn');
export const exec = PromiseWrapper('exec');