"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateRoutes = generateRoutes;

var _routesToJSON = _interopRequireDefault(require("./routesToJSON"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const filePath = (0, _utils.resolveGenerateRouterPath)('Routes.tsx');
const tpl = '/tpl/Routes.tsx.tpl';

async function generateRoutes(api) {
  var _api$userConfig$dynam;

  const {
    routes,
    importNameTemplate
  } = (0, _routesToJSON.default)(api.userConfig);
  return api.generateFile.writeFile({
    path: filePath,
    content: api.generateFile.renderTpl(api.generateFile.readTplFile(__dirname, tpl), {
      routes,
      importNameTemplate,
      loadingComponent: (_api$userConfig$dynam = api.userConfig.dynamicImport) === null || _api$userConfig$dynam === void 0 ? void 0 : _api$userConfig$dynam.loading
    })
  });
}