"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loadPlugins = exports.isPromise = void 0;

var _path = require("path");

var fs = _interopRequireWildcard(require("fs-extra"));

var _type = require("@spark-build/web-utils/lib/type");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const loadPlugins = async () => {
  const pluginsDirPath = (0, _path.join)(__dirname, '../../../plugins');
  const files = await fs.readdir(pluginsDirPath);
  return Promise.all(files.map(async id => {
    const path = (0, _path.join)(pluginsDirPath, id);

    try {
      const loadFileSetting = await new Promise((resolve, reject) => {
        try {
          resolve(require(path));
        } catch (error) {
          reject(error);
        }
      }).then(res => ({
        stage: res.stage || 0,
        fn: res.default
      }));
      return {
        id,
        path,
        ...loadFileSetting
      };
    } catch (e) {
      throw new Error(`Register ${id} ${path} failed, since ${e.message}`);
    }
  }));
};

exports.loadPlugins = loadPlugins;

const isPromise = obj => ((0, _type.isObj)(obj) || (0, _type.isFn)(obj)) && (0, _type.isFn)(obj.then);

exports.isPromise = isPromise;