"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.spawn = exports.exec = void 0;

var childProcess = _interopRequireWildcard(require("child_process"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const PromiseWrapper = cmdType => (options, isConsoleLog = true) => new Promise((resolve, reject) => {
  const result = childProcess[cmdType](options);
  const stdoutChunks = [];
  const stderrChunks = [];

  const capture = chunks => data => {
    chunks.push(data);

    if (isConsoleLog) {
      console.log(data.toString().trim());
    }
  };

  result.stdout.on('data', capture(stdoutChunks));
  result.stderr.on('data', capture(stderrChunks));
  result.on('close', () => {
    stdoutChunks.length ? resolve(stdoutChunks) : reject(stderrChunks);
  });
});

const spawn = PromiseWrapper('spawn');
exports.spawn = spawn;
const exec = PromiseWrapper('exec');
exports.exec = exec;