"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reactAutoConfig = void 0;

var _pluginReact = _interopRequireDefault(require("@vitejs/plugin-react"));

var _vitePluginWindicss = _interopRequireDefault(require("vite-plugin-windicss"));

var _vitePluginStyleImport = _interopRequireDefault(require("vite-plugin-style-import"));

var _vitePluginMkcert = _interopRequireDefault(require("vite-plugin-mkcert"));

var _reactAutoConfig = require("./reactAutoConfig");

var _Bootstrap = require("./Bootstrap");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const reactAutoConfig = async (options = {}) => {
  const bootstrap = new _Bootstrap.Bootstrap();
  await bootstrap.init();
  const {
    userConfig
  } = bootstrap.getServer();
  const plugins = [(0, _pluginReact.default)(options.react), (0, _reactAutoConfig.reactAutoConfigPluginConfig)(bootstrap)];

  if (userConfig.antd) {
    const {
      styleImport
    } = options;
    plugins.push((0, _vitePluginStyleImport.default)({ ...(styleImport || {}),
      libs: [{
        libraryName: 'antd',
        esModule: true,
        resolveStyle: name => `antd/es/${name}/style/index`
      }, {
        libraryName: '@ant-design/icons',
        libraryNameChangeCase: 'pascalCase',
        resolveComponent: name => `@ant-design/icons/es/icons/${name}`
      }, ...((styleImport === null || styleImport === void 0 ? void 0 : styleImport.libs) || [])]
    }));
  }

  if (userConfig.mkcert) {
    plugins.push((0, _vitePluginMkcert.default)({
      source: 'coding',
      ...options.mkcert
    }));
  }

  if (userConfig.windiCSS) {
    plugins.push((0, _vitePluginWindicss.default)());
  }

  return plugins;
};

exports.reactAutoConfig = reactAutoConfig;